---
title: XRSession.onselect
slug: Web/API/XRSession/onselect
tags:
  - API
  - AR
  - Augmented Reality
  - Event Handler
  - Experimental
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRSession
  - onselect
---
<div>{{securecontext_header}}{{APIRef("WebXR")}}</div>

<p><span class="seoSummary">The <code><strong>onselect</strong></code> property of the {{DOMxRef("XRSession")}} object is the event handler for the {{DOMxRef("XRSession.select_event", "select")}} event, which is dispatched when a <a href="en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_actions">primary action</a> is completed successfully by the user.</span> This typically represents the pressing of a button or trigger, a hand gesture, or a spoken command.</p>

<p>The {{domxref("XRSession.select_event", "select")}} event is sent after tracking of the primary action begins, as announced by the {{domxref("XRSession.selectstart_event", "selectstart")}} event, and immediately before the tracking of the primary action ends, which is announced by the {{domxref("XRSession.selectend_event", "selectend")}} event.</p>

<p>To learn more about how WebXR actions work, see <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrSession</em>.onselect = <em>selectHandlerFunction</em>;
</pre>

<h3 id="Value">Value</h3>

<p>An event handler function to be invoked when the {{domxref("XRSession")}} receives a {{domxref("XRSession.select_event", "select")}} event.</p>

<h2 id="Example">Example</h2>

<p>This example handles <code>select</code> event which occur on the user's main hand (as given by a <code>user</code> object's <code>handedness</code> property); if that value matches the value of the {{domxref("XRInputSource")}} property {{domxref("XRInputSource.handedness", "handedness")}}, we know that the device is held in the user's main hand.</p>

<pre class="brush: js">xrSession.onselect = event =&gt; {
  let source = event.inputSource;

  if (source.handedness == user.handedness) {
    if (source.targetRayMode == "tracked-pointer") {
      let targetRayPose = event.frame.getPose(source.targetRaySpace, myRefSpace);

      if (targetRayPose) {
        myHandleSelectWithRay(targetRayPose);
      }
    }
  }
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-onselect","XRSession.onselect")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRSession.onselect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li>{{DOMxRef("XRSession.onselectstart")}}</li>
 <li>{{DOMxRef("XRSession.onselectend")}}</li>
</ul>
